///////////////////////////////////////
//
//	CTGraphNX	F
//
///////////////////////////////////////

#include "stdafx.h"
#include "AXCAC01.h"
#include "TGraph.h"

///////////////////////////////////////
// CTGraph NX

CTGraph::CTGraph(CWnd* pWnd, CRect rc)
{
	CDC*	pDC	= NULL;

	m_nBkData	= 0;
	
	pDC	= pWnd->GetDC();
	m_rcClient = rc;						//̐F

	CBrush*		pOldBlush	= NULL;
	CBrush		BackBrush(GRAPH_BK_COLOR);
	pOldBlush	= pDC->SelectObject(&BackBrush);

	pDC->FillRect(m_rcClient, &CBrush(GRAPH_BK_COLOR));				//lp`hԂ
	CRect	rc2;
	rc2 = m_rcClient;
	InflateRect(&rc2, 1, 1);										//top,bottom1g
	pDC->FrameRect(rc2, &CBrush(GRAPH_LINE_COLOR));					//g`

	if(pOldBlush != NULL)
		pDC->SelectObject(pOldBlush);
	
	m_MemDC.CreateCompatibleDC(pDC);								//޲÷Ă̍쐬
	CBitmap		MemoryBmp;

	MemoryBmp.CreateCompatibleBitmap(pDC, m_rcClient.Width(), m_rcClient.Height());//ޯϯ߂̍쐬
	m_pOldBitmap = m_MemDC.SelectObject(&MemoryBmp);

	m_MemDC2.CreateCompatibleDC(pDC);								//޲÷Ă̍쐬
	CBitmap		MemoryBmp2;

	MemoryBmp2.CreateCompatibleBitmap(pDC, m_rcClient.Width(), m_rcClient.Height());//ޯϯ߂̍쐬
	m_pOldBitmap2 = m_MemDC2.SelectObject(&MemoryBmp2);
	m_MemDC3.CreateCompatibleDC(pDC);								//޲÷Ă̍쐬
	CBitmap		MemoryBmp3;

	MemoryBmp3.CreateCompatibleBitmap(pDC, m_rcClient.Width(), m_rcClient.Height());//ޯϯ߂̍쐬
	m_pOldBitmap3 = m_MemDC3.SelectObject(&MemoryBmp3);

	if(pDC != NULL)
		pWnd->ReleaseDC(pDC);

	m_bFirst	= TRUE;
}

CTGraph::~CTGraph()
{
	DeleteDC(m_MemDC);		//޲÷Ă̔j
	DeleteDC(m_MemDC2);		//޲÷Ă̔j
	DeleteDC(m_MemDC3);		//޲÷Ă̔j
}

VOID CTGraph::StartTimerGraph(CWnd* pWnd,double dData)
{
	CBrush*	pOldBlush	= NULL;
	CBrush	BackBrush(GRAPH_BK_COLOR);
	CRect	rcGraph		= m_rcClient;
	int		nHigh		= m_rcClient.Height();
	int		nWidth		= m_rcClient.Width();
	POINT	point;
	CDC*	pDC			= pWnd->GetDC();

	pOldBlush			= m_MemDC2.SelectObject(&BackBrush);

	m_MemDC2.FillRect(rcGraph, &CBrush(GRAPH_BK_COLOR));		//lp`hԂ
	if(pOldBlush != NULL)
		m_MemDC2.SelectObject(pOldBlush);

	// Draw Start Point
	if(dData >= 0 && dData <= 2.5)
	{
		point.x	= m_rcClient.right-1-m_rcClient.left;
//		point.y	= m_rcClient.top + (int)((double)nHigh * (dData / 2.5) + 0.5);
		point.y	= m_rcClient.bottom - (int)((double)nHigh * (dData / 2.5) + 0.5);
		if(point.y == m_rcClient.bottom)
			point.y--;
		m_MemDC2.SetPixel(point,GRAPH_COLOR);					// ߸ٕ\

		m_nBkData	= point.y;
	}
	
	// f[^ۑ
	m_MemDC.BitBlt(0,0,nWidth,nHigh,&m_MemDC2,0,0,SRCCOPY);

	// `
	pDC->BitBlt(0,0,nWidth,nHigh,&m_MemDC2,0,0,SRCCOPY);

	// ⏕`
	// ͂߂ɔwi̓h蒼
	m_MemDC2.FillRect(rcGraph, &CBrush(GRAPH_BK_COLOR));		// lp`hԂ

	DrawGraphLine(&m_MemDC2);									// ⏕`
//	pDC->BitBlt(0, 0, nWidth, nHigh, &m_MemDC2, 0, 0, SRCAND);
	pDC->BitBlt(0, 0, nWidth, nHigh, &m_MemDC2, 0, 0, SRCPAINT);
	
	if(pDC != NULL)
	{
		pWnd->ReleaseDC(pDC);
		pDC = NULL;
	}
}

VOID CTGraph::Redraw(CWnd* pWnd)
{
	int		nHigh		= m_rcClient.Height();
	int		nWidth		= m_rcClient.Width();
	CDC*	pDC			= pWnd->GetDC();

	if(m_bFirst == TRUE)
	{
		double	dData	= 0.0;

		StartTimerGraph(pWnd,dData);

		m_bFirst = FALSE;
	}
	else
	{
		pDC->BitBlt(0,0,nWidth,nHigh,&m_MemDC,0,0,SRCCOPY);
		DrawGraphLine(pDC);
	}

	if(pDC != NULL){
		pWnd->ReleaseDC(pDC);
		pDC = NULL;
	}
}

VOID CTGraph::SetDataPointer(CWnd* pWnd,double dData)
{
	int		nHigh		= m_rcClient.Height();
	int		nWidth		= m_rcClient.Width();
	CRect	rcGraph		= m_rcClient;
	int		nPos;
	CDC*	pDC			= pWnd->GetDC();
	int		nMove		= 2;
	
	// `
	// ͂߂ɔwi̓h蒼
	CBrush*	pOldBlush	= NULL;
	CBrush	BackBrush(GRAPH_BK_COLOR);

	pOldBlush		= m_MemDC2.SelectObject(&BackBrush);

	m_MemDC2.FillRect(rcGraph, &CBrush(GRAPH_BK_COLOR));					//lp`hԂ
	
	if(pOldBlush != NULL)
		m_MemDC2.SelectObject(pOldBlush);

	// ̉摜]
	m_MemDC2.BitBlt(1,0,nWidth-nMove,nHigh,&m_MemDC,nMove,0,SRCCOPY);
	
	// Draw Current Point
	CPen*	pOldPen;
	// Data-1:
	CPen	PenData(PS_SOLID,1,GRAPH_COLOR);
	if(	(dData >= 0 && dData <= 2.5) && (m_nBkData >= 0 && m_nBkData <= nHigh)	)
	{
		pOldPen	= m_MemDC2.SelectObject(&PenData);
		m_MemDC2.MoveTo(m_rcClient.left + nWidth - nMove,m_nBkData);
		nPos	= (int)((double)nHigh * (dData / 2.5) + 0.5);
//		nPos	+= m_rcClient.top;
		nPos	= m_rcClient.bottom - nPos;
		if(nPos == m_rcClient.bottom)
			nPos--;
		m_MemDC2.LineTo(m_rcClient.right - 1,nPos);

		m_nBkData	= nPos;
		m_MemDC2.SelectObject(pOldPen);
	}
	else
	{
		nPos	= (int)((double)nHigh * (dData / 2.5) + 0.5);
//		nPos	+= m_rcClient.top;
		nPos	= m_rcClient.bottom - nPos;
		if(nPos == m_rcClient.bottom)
			nPos--;
		m_nBkData	= nPos;
	}

	// f[^ۑ
	m_MemDC.BitBlt(0,0,nWidth,nHigh,&m_MemDC2,0,0,SRCCOPY);

	// `
	m_MemDC3.BitBlt(0,0,nWidth,nHigh,&m_MemDC2,0,0,SRCCOPY);

	// ⏕`
	// ͂߂ɔwi̓h蒼
	m_MemDC2.FillRect(rcGraph, &CBrush(GRAPH_BK_COLOR));					//lp`hԂ
	DrawGraphLine(&m_MemDC2);
//	m_MemDC3.BitBlt(0, 0, nWidth, nHigh, &m_MemDC2, 0, 0, SRCAND);
	m_MemDC3.BitBlt(0, 0, nWidth, nHigh, &m_MemDC2, 0, 0, SRCPAINT);
	pDC->BitBlt(0,0,nWidth,nHigh,&m_MemDC3,0,0,SRCCOPY);

	if(pDC != NULL)
	{
		pWnd->ReleaseDC(pDC);
		pDC = NULL;
	}
}

VOID CTGraph::DrawGraphLine(CDC* pDC)
{
	int		nHigh		= m_rcClient.Height();
	int		nWidth		= m_rcClient.Width();
	int		nTemp;
	double	dData[6]	= { 0, 0.5, 1.0, 1.5, 2.0, 2.5	};
	int		nY;

	// ⏕쐬
	CPen	PenLine(PS_DASH,0,GRAPH_LINE_COLOR);
	CPen*	pOldPen;
	
	// ⏕̕`
	pOldPen	= pDC->SelectObject(&PenLine);
	pDC->SetBkColor(AD_BK_COLOR);

	// c5(Xs⏕j
	nTemp	= nHigh / 5;
	for(int i = 0; i <= 5; i++)
	{
		nY	= m_rcClient.bottom - (int)((double)nHigh * (dData[i] / 2.5) + 0.5);

		pDC->MoveTo(m_rcClient.left,	nY);
		pDC->LineTo(m_rcClient.right,	nY);
//		pDC->MoveTo(m_rcClient.left,	m_rcClient.top + nTemp * i);
//		pDC->LineTo(m_rcClient.right,	m_rcClient.top + nTemp * i);
	}

	pDC->SelectObject(pOldPen);
}

