// DADlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AXCAC01.h"
#include "DADlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDADlg _CAO


CDADlg::CDADlg(CAXCAC01Doc* pDoc,CWnd* pParent /*=NULL*/)
	: CDialog(CDADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDADlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	
	m_pDoc	= pDoc;
}


void CDADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDADlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	DDX_Control(pDX, IDC_TITLE1_BUTTON,	m_Title1Btn);
	DDX_Control(pDX, IDC_TITLE2_BUTTON,	m_Title2Btn);
	DDX_Control(pDX, IDC_CH0_RADIO,		m_Ch0Radio);
	DDX_Control(pDX, IDC_CH1_RADIO,		m_Ch1Radio);
	DDX_Control(pDX, IDC_OUTPUT_BUTTON,	m_OutputBtn);
	DDX_Control(pDX, IDC_VAL_STATIC,	m_ValueStatic);
	DDX_Control(pDX, IDC_1MV_RADIO,		m_1MVRadio);
	DDX_Control(pDX, IDC_10MV_RADIO,	m_10MVRadio);
	DDX_Control(pDX, IDC_100MV_RADIO,	m_100MVRadio);
	DDX_Control(pDX, IDC_1V_RADIO,		m_1VRadio);
	DDX_Control(pDX, IDC_OUTPUT_STATIC,	m_OutDACtrl);
	DDX_Control(pDX, IDC_UP_BUTTON,		m_UpBtn);
	DDX_Control(pDX, IDC_DOWN_BUTTON,	m_DownBtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDADlg, CDialog)
	//{{AFX_MSG_MAP(CDADlg)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_OUTPUT_BUTTON, OnOutputButton)
	ON_BN_CLICKED(IDC_UP_BUTTON, OnUpButton)
	ON_BN_CLICKED(IDC_DOWN_BUTTON, OnDownButton)
	ON_BN_CLICKED(IDC_CH0_RADIO, OnCh0Radio)
	ON_BN_CLICKED(IDC_CH1_RADIO, OnCh1Radio)
	ON_BN_CLICKED(IDC_1MV_RADIO, On1mvRadio)
	ON_BN_CLICKED(IDC_10MV_RADIO, On10mvRadio)
	ON_BN_CLICKED(IDC_100MV_RADIO, On100mvRadio)
	ON_BN_CLICKED(IDC_1V_RADIO, On1vRadio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDADlg bZ[W nh

BOOL CDADlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// Bitmap Button ̐ݒ
	m_Title1Btn.SetDocument(m_pDoc);
	m_Title2Btn.SetDocument(m_pDoc);
	m_OutputBtn.SetDocument(m_pDoc);
	m_UpBtn.SetDocument(m_pDoc);
	m_DownBtn.SetDocument(m_pDoc);

	CString	strFont;
	strFont = TEXT("lr@SVbN");

	m_Title1Font.CreateFont(-15,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_Title1Btn.SetFont(&m_Title1Font);

	m_Title2Font.CreateFont(-12,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_Title2Btn.SetFont(&m_Title2Font);

	m_TextFont.CreateFont(-12,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_Ch0Radio.SetFont(&m_TextFont);
	m_Ch1Radio.SetFont(&m_TextFont);
	m_ValueStatic.SetFont(&m_TextFont);
	m_1MVRadio.SetFont(&m_TextFont);
	m_10MVRadio.SetFont(&m_TextFont);
	m_100MVRadio.SetFont(&m_TextFont);
	m_1VRadio.SetFont(&m_TextFont);

	m_DAFont.CreateFont(-30,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_OutDACtrl.SetFont(&m_DAFont);

	if(m_pDoc->GetDAChannel() == 0)
	{
		m_Ch0Radio.SetCheck(1);
		m_Ch1Radio.SetCheck(0);
	}
	else if(m_pDoc->GetDAChannel() == 1)
	{
		m_Ch0Radio.SetCheck(0);
		m_Ch1Radio.SetCheck(1);
	}

	if(m_pDoc->GetDAValueSel() == AXC_DA_1MV)
	{
		m_1MVRadio.SetCheck(1);
		m_10MVRadio.SetCheck(0);
		m_100MVRadio.SetCheck(0);
		m_1VRadio.SetCheck(0);
	}
	else if(m_pDoc->GetDAValueSel() == AXC_DA_10MV)
	{
		m_1MVRadio.SetCheck(0);
		m_10MVRadio.SetCheck(1);
		m_100MVRadio.SetCheck(0);
		m_1VRadio.SetCheck(0);
	}
	else if(m_pDoc->GetDAValueSel() == AXC_DA_100MV)
	{
		m_1MVRadio.SetCheck(0);
		m_10MVRadio.SetCheck(0);
		m_100MVRadio.SetCheck(1);
		m_1VRadio.SetCheck(0);
	}
	else if(m_pDoc->GetDAValueSel() == AXC_DA_1V)
	{
		m_1MVRadio.SetCheck(0);
		m_10MVRadio.SetCheck(0);
		m_100MVRadio.SetCheck(0);
		m_1VRadio.SetCheck(1);
	}

//////////////////////////////////////////////////////////////////////////////
// for PocketPC2003
// 2004/09/08 +++<S>+++
	ShowWindow(SW_SHOW);
// 2004/09/08 +++<E>+++
//////////////////////////////////////////////////////////////////////////////

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDADlg::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	CRect	rcFrame;
	CRect	rc;
	GetWindowRect(&rcFrame);

	dc.FillRect(rcFrame, &CBrush(BACKGROUND_COLOR));			//lp`hԂ

	rc.left		= DA_STARTBTN_X-5;
	rc.top		= DA_BAR_Y2;
	rc.right	= rcFrame.Width();
	rc.bottom	= DA_BAR_Y2+GPIO_BAR_HEIGHT;
	dc.FillRect(rc, &CBrush(::GetSysColor(COLOR_3DFACE)));			//lp`hԂ

	m_Title1Btn.MoveWindow(0			,DA_BAR_Y1		,rcFrame.Width()	,DA_BAR_HEIGHT);
	m_Title2Btn.MoveWindow(0			,DA_BAR_Y2		,DA_STARTBTN_X-5	,DA_BAR_HEIGHT);
	m_OutputBtn.MoveWindow(DA_STARTBTN_X,DA_STARTBTN_Y	,DA_STARTBTN_WIDTH	,DA_STARTBTN_HIGHT);
	m_UpBtn.MoveWindow(DA_UPBTN_X		,DA_UPBTN_Y		,DA_UPDWNBTN_WIDTH	,DA_UPDWNBTN_HIGHT);
	m_DownBtn.MoveWindow(DA_DOWNBTN_X	,DA_DOWNBTN_Y	,DA_UPDWNBTN_WIDTH	,DA_UPDWNBTN_HIGHT);
	m_OutDACtrl.MoveWindow(DA_VALUE_X	,DA_VALUE_Y		,DA_VALUE_WIDTH		,DA_VALUE_HIGHT);
	
	
	// E`
	CPen*	pOldPen;
	CPen	PenData1(PS_SOLID,1,PEN1_COLOR);
	CPen	PenData2(PS_SOLID,1,PEN2_COLOR);

	pOldPen		= dc.SelectObject(&PenData2);
	dc.MoveTo(0,DA_BAR_Y1+DA_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),DA_BAR_Y1+DA_BAR_HEIGHT);
	
	dc.MoveTo(0,DA_BAR_Y2-1);
	dc.LineTo(rcFrame.Width(),DA_BAR_Y2-1);
	dc.MoveTo(0,DA_BAR_Y2+DA_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),DA_BAR_Y2+DA_BAR_HEIGHT);
	
	dc.MoveTo(0,DA_BAR_Y3);
	dc.LineTo(rcFrame.Width(),DA_BAR_Y3);
	
	dc.SelectObject(pOldPen);

	// `pbZ[WƂ CDialog::OnPaint() ĂяoĂ͂܂
}

HBRUSH CDADlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		if(pWnd == &m_OutDACtrl)
		{
			pDC->SetTextColor(AD_FACE_COLOR);
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(AD_BK_COLOR);
		}
		if(pWnd == &m_ValueStatic)
		{
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(BACKGROUND_COLOR);
		}
		if(	(pWnd == &m_Ch0Radio)	||
			(pWnd == &m_Ch1Radio)	||
			(pWnd == &m_1MVRadio)	||
			(pWnd == &m_10MVRadio)	||
			(pWnd == &m_100MVRadio)	||
			(pWnd == &m_1VRadio)	)
		{
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(BACKGROUND_COLOR);
		}
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

void CDADlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// o͒
	if(m_pDoc->GetDAOut())
	{
		CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
		INT				nCh		= 0;
		WORD			wData;

		wData	= 0;
		pApp->m_AxcAcCtrl.SetDAValue(nCh,wData);
		nCh		= 1;
		pApp->m_AxcAcCtrl.SetDAValue(nCh,wData);
	}

	m_Title1Font.DeleteObject();		//̫ĵ޼ުĂ̔j;
	m_Title2Font.DeleteObject();		//̫ĵ޼ުĂ̔j;
	m_TextFont.DeleteObject();			//̫ĵ޼ުĂ̔j;
	m_DAFont.DeleteObject();			//̫ĵ޼ުĂ̔j;
}

void CDADlg::OnOutputButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nCh		= m_pDoc->GetDAChannel();
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
	
	if(m_pDoc->GetDAOut())
	{	// o͒ ON -> OFF
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,0))
		{
			return;
		}

		m_pDoc->SetDAOut(FALSE);
	}
	else
	{	// ~ OFF -> ON
		double		dValue	= m_pDoc->GetDAValue();
		double		dTemp;
		WORD		wData;

//		dTemp	= ((double)DA_VAL_MAX / (double)(0xfff)) * dValue;
		dTemp	= dValue / (double)DA_VAL_MAX;
		dTemp	*= (double)(0xfff);
		wData	= (WORD)dTemp;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}

		m_pDoc->SetDAOut(TRUE);
	}
	m_OutputBtn.Invalidate();
}

void CDADlg::OnUpButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	double	dValue	= m_pDoc->GetDAValue();
	
	if(dValue >= DA_VAL_MAX)
		return;
	
	if(m_pDoc->GetDAValueSel() == AXC_DA_1MV)
		dValue += 0.001;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_10MV)
		dValue += 0.010;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_100MV)
		dValue += 0.100;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_1V)
		dValue += 1.000;

	if(dValue > DA_VAL_MAX)
		dValue	= DA_VAL_MAX;
	
	m_pDoc->SetDAValue(dValue);

	CString	strBuff;

	strBuff.Format(TEXT("%.3fv"),dValue);
	m_OutDACtrl.SetWindowText(strBuff);

	// o͒
	if(m_pDoc->GetDAOut())
	{
		CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
		INT				nCh		= m_pDoc->GetDAChannel();
		double			dTemp;
		WORD			wData;

		dTemp	= dValue / (double)DA_VAL_MAX;
		dTemp	*= (double)(0xfff);
		wData	= (WORD)dTemp;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}
	}
}

void CDADlg::OnDownButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	double	dValue	= m_pDoc->GetDAValue();
	
	if(dValue <= DA_VAL_MIN)
		return;
	
	if(m_pDoc->GetDAValueSel() == AXC_DA_1MV)
		dValue -= 0.001;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_10MV)
		dValue -= 0.010;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_100MV)
		dValue -= 0.100;
	else if(m_pDoc->GetDAValueSel() == AXC_DA_1V)
		dValue -= 1.000;

	if(dValue < DA_VAL_MIN)
		dValue	= DA_VAL_MIN;
	
	m_pDoc->SetDAValue(dValue);

	CString	strBuff;

	strBuff.Format(TEXT("%.3fv"),dValue);
	m_OutDACtrl.SetWindowText(strBuff);

	// o͒
	if(m_pDoc->GetDAOut())
	{
		CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
		INT				nCh		= m_pDoc->GetDAChannel();
		double			dTemp;
		WORD			wData;

		dTemp	= dValue / (double)DA_VAL_MAX;
		dTemp	*= (double)(0xfff);
		wData	= (WORD)dTemp;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}
	}
}

void CDADlg::OnCh0Radio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDACannel(0);

	// o͒
	if(m_pDoc->GetDAOut())
	{
		CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
		INT				nCh		= 0;
		double			dValue	= m_pDoc->GetDAValue();
		double			dTemp;
		WORD			wData;

		dTemp	= dValue / (double)DA_VAL_MAX;
		dTemp	*= (double)(0xfff);
		wData	= (WORD)dTemp;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}

		wData	= 0;
		nCh		= 1;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}
	}
}

void CDADlg::OnCh1Radio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDACannel(1);

	// o͒
	if(m_pDoc->GetDAOut())
	{
		CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
		INT				nCh		= 1;
		double			dValue	= m_pDoc->GetDAValue();
		double			dTemp;
		WORD			wData;

		dTemp	= dValue / (double)DA_VAL_MAX;
		dTemp	*= (double)(0xfff);
		wData	= (WORD)dTemp;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}

		wData	= 0;
		nCh		= 0;
		if(!pApp->m_AxcAcCtrl.SetDAValue(nCh,wData))
		{
			return;
		}
	}
}

void CDADlg::On1mvRadio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDAValueSel(AXC_DA_1MV);
}

void CDADlg::On10mvRadio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDAValueSel(AXC_DA_10MV);
}

void CDADlg::On100mvRadio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDAValueSel(AXC_DA_100MV);
}

void CDADlg::On1vRadio() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_pDoc->SetDAValueSel(AXC_DA_1V);
}
