///////////////////////////////////////
//
//	CAxcAcCtrlNX	F@VAʐMNX
//
///////////////////////////////////////


#ifndef	_AXC_AC01_CTRL_H
#define	_AXC_AC01_CTRL_H

#include "Comu.h"


///////////////////////////////////////
// CAxcAcCtrl NX

class CAxcAcCtrl
{
protected:
	CComu		m_Com;

public:
// Iy[V
	CAxcAcCtrl();					// ݽ׸
	~CAxcAcCtrl();					// ޽׸

	BOOL	Initialize(PINT pPortNo, PINT pAxcCard);
	VOID	Terminate();

	BOOL	SetADSampleEnd(INT nMode);
	BOOL	SetADClockSrc(INT nSrc);
	BOOL	SetADClockBase(INT nBase);
	BOOL	SetADClockTime(INT nTime);
	BOOL	SetADSamplingNum(INT nNumSet);
	BOOL	SetADExtTrig(INT nTrig);
	BOOL	SetADTrgStart();
	BOOL	SetADStop();
	BOOL	GetADDmaStatus(PBYTE pMode,PBYTE pCode);
	BOOL	GetADDmaResult(PBYTE pMode,PBYTE pCode);
	BOOL	GetADData(INT nCh,double* pBuffer,WORD wBufSize);
	BOOL	GetSingleData(double* pData1,double* pData2);

	BOOL	SetDAValue(INT nCh,WORD wValue);		// nCh = 0 or 1, wValue(12bit)

	BOOL	SetPortData(INT nPort,INT nLevel);		// nLevel = 0:LOW(0),1:HIGH(1)
	BOOL	GetPortData(INT nPort,PBYTE pData);		// pData = 0 or 1
	BOOL	GetPortAAData(double* pData);			// Port-A AD(10bit)
	BOOL	SetPortMode(INT nPort,INT nMode);

private:
	VOID	CommandOutputError(LPTSTR pCmd);
	VOID	ResponseError(LPTSTR pCmd);
	VOID	TimeoutError(LPTSTR pCmd);
	BOOL	CheckConnection(void);

	INT		m_nPort;
	INT		m_nAxcCard;

	INT		m_nADSampleEnd;
	INT		m_nADClockSrc;
	INT		m_nADClockBase;
	INT		m_nADClockTime;
	INT		m_nSamplingNumSet;
	INT		m_nADTrigger;
	
	INT		m_nPortMode[4];
	BOOL	m_bConnectionError;
};

#endif
