// BmpBtn.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AXCAC01.h"
#include "BmpBtn.h"
//#include "typedef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CBmpBtn

//***********************************************************************
//	֐F׽̍\z
//	֐@FCBmpBtn
//***********************************************************************
CBmpBtn::CBmpBtn()
	: m_ShowFocus(TRUE)
{
	m_pDoc	= NULL;

}

//***********************************************************************
//	֐F׽̔j
//	֐@F~CBmpBtn
//***********************************************************************
CBmpBtn::~CBmpBtn()
{
}


BEGIN_MESSAGE_MAP(CBmpBtn, COwnerBtn)
	//{{AFX_MSG_MAP(CBmpBtn)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpBtn bZ[W nh

//***********************************************************************
//	֐Fĕ`
//	֐@FInvalidate
//***********************************************************************
void CBmpBtn::Invalidate()
{
	if (m_hWnd)
		COwnerBtn::Invalidate(FALSE);			//ĕ`
}

//***********************************************************************
//	֐F݂̫L׸ނ
//	֐@FShowFocus
//		F  BOOL	tf		̫׸
//***********************************************************************
void CBmpBtn::ShowFocus(BOOL tf)
{
	m_ShowFocus = tf;				//̫׸޾
	Invalidate();					//ĕ`
}

// virtual
//***********************************************************************
//	֐F݂÷Ă\
//	֐@FonDisplayText
//		F	CDC*				pDC		޲÷
//				const CRect			rrc		̈
//				LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::onDisplayText(CDC* pDC, const CRect& rrc, LPDRAWITEMSTRUCT lpDIS)
{
	CRect	rc(rrc);
	CString txt;
	int		y	= 0;
	int		x	= 0;

	if(	(lpDIS->CtlID == IDC_TITLE1_BUTTON)	||
		(lpDIS->CtlID == IDC_TITLE2_BUTTON)	)
	{
		x	= 5;
		y	= 5;
	}
	else if(lpDIS->CtlID == IDC_AD_BUTTON)
	{
		if(m_pDoc->GetAxcCF() == AXC_DA_CF)
			pDC->SetTextColor(PEN2_COLOR);
		else
			pDC->SetTextColor(SELECT_MENU_COLOR);

		x	= 25;
		y	= 2;
	}
	else if(lpDIS->CtlID == IDC_DA_BUTTON)
	{
		if(m_pDoc->GetAxcCF() == AXC_AD_CF)
			pDC->SetTextColor(PEN2_COLOR);
		else
			pDC->SetTextColor(SELECT_MENU_COLOR);

		x	= 25;
		y	= 2;
	}
	else if(lpDIS->CtlID == IDC_GPIO_BUTTON)
	{
		pDC->SetTextColor(SELECT_MENU_COLOR);

		x	= 25;
		y	= 2;
	}

	GetWindowText(txt);
	if (!txt.IsEmpty()) 
	{	//÷ĂNULLłȂꍇ
		// ߃[hɂāc
		pDC->SetBkMode(TRANSPARENT);
		// ̕KvƂ̈vZ
		CRect drc(rc);
		pDC->ExtTextOut(x,y,ETO_CLIPPED,&drc,(LPCTSTR)txt,txt.GetLength(),NULL);
	}
}

//////////////////////////////////////////////////////////
// I[i[h[̃nh
//***********************************************************************
//	֐FŰ۰
//	֐@FDrawItem
//		F	LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
{
	// TODO: w肳ꂽACe`悷邽߂̃R[hǉĂ
	
	// DC̃nhCDCNX̃IuWFNg쐬
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);
	// DC̑Sۑ
	pDC->SaveDC();
	// `悷ׂ̈
	CRect rc = lpDIS->rcItem;

	int		nBitsPixel = pDC->GetDeviceCaps(BITSPIXEL);

	if (lpDIS->itemAction & (ODA_DRAWENTIRE | ODA_SELECT)) 
	{	// {^{̂̕`悪Kvł
		// DrawFrameControl()Ăяoۂ̃tO
		UINT flag = /*DFCS_ADJUSTRECT | */DFCS_BUTTONPUSH;

		// vbV{^̏ꍇAODA_SELECT̓vbVĂ邱ƂӖ
		if (lpDIS->itemState & ODS_SELECTED) 
		{
			// ݉Ă
			flag |= DFCS_PUSHED;
		}

		if(nBitsPixel <= 8)	
		{	// ghԂ
			CBrush brush(RGB(0,0,160));
			pDC->FillRect(rc, &brush);
		}
		else if((lpDIS->CtlID == IDC_TITLE1_BUTTON)	||
				(lpDIS->CtlID == IDC_TITLE2_BUTTON)	)
		{
			CBrush brush(::GetSysColor(COLOR_3DFACE));
			pDC->FillRect(rc, &brush);
		}
		else if((lpDIS->CtlID == IDC_AD_BUTTON)	||
				(lpDIS->CtlID == IDC_DA_BUTTON)	||
				(lpDIS->CtlID == IDC_GPIO_BUTTON)	)
		{
			CBrush brush(BACKGROUND_COLOR);
			pDC->FillRect(rc, &brush);
			DrawButtonBmp(pDC,&rc,lpDIS);
		}
		else 
		{	// {^a̕`
			CBrush brush(BACKGROUND_COLOR);
			pDC->FillRect(rc, &brush);
			DrawButtonBmp(pDC,&rc,lpDIS);
		}

		m_InnerRc = rc;

		// {^̕`
		onDisplayText(pDC, rc, lpDIS);
	}

	if (m_ShowFocus && ((lpDIS->itemAction & ODA_FOCUS) || (lpDIS->itemState & ODS_FOCUS)))
	{
		// IF̍ĕ`
		onDisplayText(pDC, rc, lpDIS);
	}
	pDC->RestoreDC(-1);
}


//***********************************************************************
//	֐F݂ޯϯ߂\t
//	֐@FDrawButtonBmp
//		F	CDC*				pDC		޲÷
//				const CRect			rrc		̈
//				LPDRAWITEMSTRUCT	lpDIS	ݏ
//***********************************************************************
void CBmpBtn::DrawButtonBmp(CDC *pDC,CRect *pRect,LPDRAWITEMSTRUCT lpDIS)
{
	WORD	wBmpID	= 0;
	WORD	wCtrlID	= lpDIS->CtlID;

	if(wCtrlID == IDC_CF_BUTTON)
	{
		if(m_pDoc->GetAxcCF() == AXC_AC_CF)
			wBmpID = IDB_AC_BMP;
		if(m_pDoc->GetAxcCF() == AXC_AD_CF)
			wBmpID = IDB_AD_BMP;
		if(m_pDoc->GetAxcCF() == AXC_DA_CF)
			wBmpID = IDB_DA_BMP;
	}
	else if(wCtrlID == IDC_LOGO_BUTTON)
	{
		wBmpID = IDB_LOGO_BMP;
	}
	else if((wCtrlID == IDC_AD_BUTTON)	||
			(wCtrlID == IDC_DA_BUTTON)	||
			(wCtrlID == IDC_GPIO_BUTTON)	)
	{
		wBmpID = IDB_SEL_BMP;
	}
	else
		return;

	CDC		dcMem;
	BITMAP	bm;
	CBitmap bitmap;
	bitmap.LoadBitmap(wBmpID);												//ޯϯߓǂݍ

	bitmap.GetObject(sizeof(BITMAP), &bm);
	dcMem.CreateCompatibleDC(pDC);											//޲÷Ă̍쐬
	CBitmap*	pOldBitmap = dcMem.SelectObject(&bitmap);					//޼ުđI

	pDC->BitBlt(pRect->left, pRect->top, pRect->Width(), pRect->Height(), &dcMem, 
					0, 0, SRCCOPY);											//ޯϯߓ\t
//	pDC->StretchBlt(pRect->left, pRect->top, pRect->Width(), pRect->Height(), &dcMem, 
//					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);				//ޯϯߓ\t

	dcMem.SelectObject(pOldBitmap);											//޼ުĂ̑I
	dcMem.DeleteDC();														//޲÷Ẳ
}

//***********************************************************************
//	֐FװگĂ̍쐬
//	֐@FShowFocus
//		F	CPalette *	pBitmapPal	گď
//				LPSTR 		lpBit		BITMAPINFOHEADER\
//	߂l	F	(TRUE)A(FALSE)s
//***********************************************************************
BOOL CBmpBtn::MakePalette(CPalette *pBitmapPal, LPSTR lpBit)
{
	//DIB̃J[̎擾
	int	wNumColors;

	WORD wBitCount = ((LPBITMAPINFOHEADER)lpBit)->biBitCount;			//ޯĶĎ擾
	switch(wBitCount) {													//F
		case 1:		wNumColors = 2;		break;
		case 4:		wNumColors = 16;	break;
		case 8:		wNumColors = 256;	break;
		default:	wNumColors = 0;		break;
	}

//
	LPLOGPALETTE	lpPal;
	HANDLE			hLogPal;
	HPALETTE		hpal = NULL;

	hLogPal = ::GlobalAlloc(GHND, sizeof(LOGPALETTE)+sizeof(PALETTEENTRY)*wNumColors);	//؂̊蓖

	if(hLogPal == NULL)
		return	FALSE;

	lpPal = (LPLOGPALETTE) GlobalLock((HGLOBAL)hLogPal);							//ؗ̈m

	lpPal->palVersion = 0x300;
	lpPal->palNumEntries = (WORD)wNumColors;
	for(int i=0;i<(int)wNumColors;i++) {
		lpPal->palPalEntry[i].peRed		= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbRed;
		lpPal->palPalEntry[i].peGreen	= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbGreen;
		lpPal->palPalEntry[i].peBlue	= ((LPBITMAPINFO)lpBit)->bmiColors[i].rgbBlue;
		lpPal->palPalEntry[i].peFlags	= 0;
	}

	BOOL bCreate = pBitmapPal->CreatePalette(lpPal);								//װگč쐬

	GlobalUnlock((HGLOBAL)hLogPal);													//؂̱ۯ
	GlobalFree((HGLOBAL)hLogPal);													//؂̉

	return bCreate;
}


//***********************************************************************
//	֐FhLgNXւ̃|C^̓o^
//	֐@FSetDocument
//		F	CAXCAC01Doc *	pDoc	CAXCAC01DocihLgjNX̃|C^
//***********************************************************************
void CBmpBtn::SetDocument(CAXCAC01Doc* pDoc)
{
	m_pDoc	= pDoc;
}


