// GPIODlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AXCAC01.h"
#include "GPIODlg.h"
#include "GPIOSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGPIODlg _CAO


CGPIODlg::CGPIODlg(CAXCAC01Doc* pDoc,CWnd* pParent /*=NULL*/)
	: CDialog(CGPIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGPIODlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	
	m_pDoc		= pDoc;
	m_uTimer	= 0;
}


void CGPIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGPIODlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	DDX_Control(pDX, IDC_TITLE1_BUTTON,	m_Title1Btn);
	DDX_Control(pDX, IDC_PORTA_BUTTON,	m_PortABtn);
	DDX_Control(pDX, IDC_PORTB_BUTTON,	m_PortBBtn);
	DDX_Control(pDX, IDC_PORTC_BUTTON,	m_PortCBtn);
	DDX_Control(pDX, IDC_PORTD_BUTTON,	m_PortDBtn);
	DDX_Control(pDX, IDC_SET_BUTTON,	m_SetBtn);
	DDX_Control(pDX, IDC_PA_BUTTON,		m_PABtn);
	DDX_Control(pDX, IDC_PB_BUTTON,		m_PBBtn);
	DDX_Control(pDX, IDC_PC_BUTTON,		m_PCBtn);
	DDX_Control(pDX, IDC_PD_BUTTON,		m_PDBtn);
	DDX_Control(pDX, IDC_START_BUTTON,	m_StartBtn);
	DDX_Control(pDX, IDC_INA_STATIC, 	m_INACtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGPIODlg, CDialog)
	//{{AFX_MSG_MAP(CGPIODlg)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_PA_BUTTON, OnPaButton)
	ON_BN_CLICKED(IDC_PB_BUTTON, OnPbButton)
	ON_BN_CLICKED(IDC_PC_BUTTON, OnPcButton)
	ON_BN_CLICKED(IDC_PD_BUTTON, OnPdButton)
	ON_BN_CLICKED(IDC_SET_BUTTON, OnSetButton)
	ON_BN_CLICKED(IDC_START_BUTTON, OnStartButton)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGPIODlg bZ[W nh

BOOL CGPIODlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// Bitmap Button ̐ݒ
	m_Title1Btn.SetDocument(m_pDoc);
	m_PortABtn.SetDocument(m_pDoc);
	m_PortBBtn.SetDocument(m_pDoc);
	m_PortCBtn.SetDocument(m_pDoc);
	m_PortDBtn.SetDocument(m_pDoc);
	m_SetBtn.SetDocument(m_pDoc);
	m_PABtn.SetDocument(m_pDoc);
	m_PBBtn.SetDocument(m_pDoc);
	m_PCBtn.SetDocument(m_pDoc);
	m_PDBtn.SetDocument(m_pDoc);
	m_StartBtn.SetDocument(m_pDoc);

	CString	strFont;
	strFont = TEXT("lr@SVbN");

	m_TitleFont.CreateFont(-15,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_Title1Btn.SetFont(&m_TitleFont);
	m_PortABtn.SetFont(&m_TitleFont);
	m_PortBBtn.SetFont(&m_TitleFont);
	m_PortCBtn.SetFont(&m_TitleFont);
	m_PortDBtn.SetFont(&m_TitleFont);

	m_ADFont.CreateFont(-30,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_INACtrl.SetFont(&m_ADFont);

	m_uTimer	= SetTimer(1, 300, NULL);			//\pϰN

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CGPIODlg::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	CRect	rcFrame;
	CRect	rc;
	GetWindowRect(&rcFrame);

	dc.FillRect(rcFrame, &CBrush(BACKGROUND_COLOR));			//lp`hԂ

	m_Title1Btn.MoveWindow(0				,GPIO_BAR_Y1	,rcFrame.Width()/2	,GPIO_BAR_HEIGHT);
	m_PortABtn.MoveWindow(0					,GPIO_BAR_Y2	,rcFrame.Width()/4	,GPIO_BAR_HEIGHT);
	m_PortBBtn.MoveWindow(rcFrame.Width()/2+1,GPIO_BAR_Y2	,rcFrame.Width()/2	,GPIO_BAR_HEIGHT);
	m_PortCBtn.MoveWindow(0					,GPIO_BAR_Y3	,rcFrame.Width()/2	,GPIO_BAR_HEIGHT);
	m_PortDBtn.MoveWindow(rcFrame.Width()/2+1,GPIO_BAR_Y3	,rcFrame.Width()/2	,GPIO_BAR_HEIGHT);

	rc.left		= rcFrame.Width()/2;
	rc.top		= 0;
	rc.right	= rcFrame.Width();
	rc.bottom	= GPIO_BAR_HEIGHT;
	dc.FillRect(rc, &CBrush(::GetSysColor(COLOR_3DFACE)));			//lp`hԂ

	rc.left		= rcFrame.Width()/4;
	rc.top		= GPIO_BAR_Y2;
	rc.right	= rcFrame.Width()/2;
	rc.bottom	= GPIO_BAR_Y2+GPIO_BAR_HEIGHT;
	dc.FillRect(rc, &CBrush(::GetSysColor(COLOR_3DFACE)));			//lp`hԂ

	// {^̔zu
	if(m_pDoc->GetPortASet() == AXC_IO_IN_AD)
	{
		m_PABtn.MoveWindow(0,0,0,0);

		m_StartBtn.MoveWindow(GPIO_STARTBTN_X,GPIO_STARTBTN_Y,GPIO_STARTBTN_WIDTH,GPIO_STARTBTN_HIGHT);
		m_INACtrl.MoveWindow(GPIO_STATIC_X1,GPIO_STATIC_Y1,GPIO_STATIC_WIDTH,GPIO_STATIC_HEIGHT);
	}
	else
	{
		m_PABtn.MoveWindow(GPIO_BTN_X1,GPIO_BTN_Y1,GPIO_BTN_WIDTH,GPIO_BTN_HEIGHT);
	
		m_StartBtn.MoveWindow(0,0,0,0);
		m_INACtrl.MoveWindow(0,0,0,0);
	}
	m_PBBtn.MoveWindow(GPIO_BTN_X2,GPIO_BTN_Y1,GPIO_BTN_WIDTH,GPIO_BTN_HEIGHT);
	m_PCBtn.MoveWindow(GPIO_BTN_X1,GPIO_BTN_Y2,GPIO_BTN_WIDTH,GPIO_BTN_HEIGHT);
	m_PDBtn.MoveWindow(GPIO_BTN_X2,GPIO_BTN_Y2,GPIO_BTN_WIDTH,GPIO_BTN_HEIGHT);
	m_SetBtn.MoveWindow(GPIO_SETBTN_X,GPIO_SETBTN_Y,GPIO_STARTBTN_WIDTH,GPIO_STARTBTN_HIGHT);

	// E`
	CPen*	pOldPen;
	CPen	PenData1(PS_SOLID,1,PEN1_COLOR);
	CPen	PenData2(PS_SOLID,1,PEN2_COLOR);

	pOldPen		= dc.SelectObject(&PenData2);
	dc.MoveTo(0,GPIO_BAR_Y1+GPIO_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y1+GPIO_BAR_HEIGHT);
	dc.MoveTo(0,GPIO_BAR_Y1+GPIO_BAR_HEIGHT+1);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y1+GPIO_BAR_HEIGHT+1);
	
	dc.MoveTo(0,GPIO_BAR_Y2+GPIO_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y2+GPIO_BAR_HEIGHT);

	dc.MoveTo(0,GPIO_BAR_Y3-1);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y3-1);
	dc.MoveTo(0,GPIO_BAR_Y3+GPIO_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y3+GPIO_BAR_HEIGHT);

	dc.MoveTo(0,GPIO_BAR_Y4);
	dc.LineTo(rcFrame.Width(),GPIO_BAR_Y4);

	dc.MoveTo(rcFrame.Width()/2,GPIO_BAR_Y1+GPIO_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width()/2,GPIO_BAR_Y4);

	dc.SelectObject(pOldPen);

	// `pbZ[WƂ CDialog::OnPaint() ĂяoĂ͂܂
}

HBRUSH CGPIODlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		if(pWnd == &m_INACtrl)
		{
			pDC->SetTextColor(AD_FACE_COLOR);
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(AD_BK_COLOR);
		}
	}
	
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

void CGPIODlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// ͂߂Ƀ^C}[~߂
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}

	m_TitleFont.DeleteObject();			//̫ĵ޼ުĂ̔j
	m_ADFont.DeleteObject();			//̫ĵ޼ުĂ̔j
}

void CGPIODlg::OnPaButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nPortSet	= m_pDoc->GetPortASet();
	CAXCAC01App*	pApp		= (CAXCAC01App*)AfxGetApp();
	
	if(	(nPortSet == AXC_IO_OUT_O)	||
		(nPortSet == AXC_IO_OUT_P)	)
	{
		BYTE	byData	= m_pDoc->GetOutData();
		if(byData & 0x01)
		{	// High -> Low
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_LOW))
				return;

			byData	&= 0xfe;
			m_pDoc->SetOutData(byData);
		}
		else
		{	// Low -> High
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_HIGH))
				return;

			byData	|= 0x01;
			m_pDoc->SetOutData(byData);
		}
		m_PABtn.Invalidate();
	}
}

void CGPIODlg::OnPbButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nPortSet	= m_pDoc->GetPortBSet();
	CAXCAC01App*	pApp		= (CAXCAC01App*)AfxGetApp();
	
	if(	(nPortSet == AXC_IO_OUT_O)	||
		(nPortSet == AXC_IO_OUT_P)	)
	{
		BYTE	byData	= m_pDoc->GetOutData();
		if(byData & 0x02)
		{	// High -> Low
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_LOW))
				return;

			byData	&= 0xfd;
			m_pDoc->SetOutData(byData);
		}
		else
		{	// Low -> High
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_HIGH))
				return;

			byData	|= 0x02;
			m_pDoc->SetOutData(byData);
		}
		m_PBBtn.Invalidate();
	}
}

void CGPIODlg::OnPcButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nPortSet	= m_pDoc->GetPortCSet();
	CAXCAC01App*	pApp		= (CAXCAC01App*)AfxGetApp();
	
	if(	(nPortSet == AXC_IO_OUT_O)	||
		(nPortSet == AXC_IO_OUT_P)	)
	{
		BYTE	byData	= m_pDoc->GetOutData();
		if(byData & 0x04)
		{	// High -> Low
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_LOW))
				return;

			byData	&= 0xfb;
			m_pDoc->SetOutData(byData);
		}
		else
		{	// Low -> High
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_HIGH))
				return;

			byData	|= 0x04;
			m_pDoc->SetOutData(byData);
		}
		m_PCBtn.Invalidate();
	}
}

void CGPIODlg::OnPdButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nPortSet	= m_pDoc->GetPortDSet();
	CAXCAC01App*	pApp		= (CAXCAC01App*)AfxGetApp();
	
	if(	(nPortSet == AXC_IO_OUT_O)	||
		(nPortSet == AXC_IO_OUT_P)	)
	{
		BYTE	byData	= m_pDoc->GetOutData();
		if(byData & 0x08)
		{	// High -> Low
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_LOW))
				return;

			byData	&= 0xf7;
			m_pDoc->SetOutData(byData);
		}
		else
		{	// Low -> High
			if(!pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_HIGH))
				return;

			byData	|= 0x08;
			m_pDoc->SetOutData(byData);
		}
		m_PDBtn.Invalidate();
	}
}

void CGPIODlg::OnSetButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// ͂߂Ƀ^C}[~߂
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);						//ϰI
		m_uTimer = 0;								//
	}

	CGPIOSetDlg*	pDlg;

	pDlg	= new CGPIOSetDlg(m_pDoc);

	pDlg->DoModal();

	delete	pDlg;

	// ^C}[̍ăX^[g
	m_uTimer	= SetTimer(1, 100, NULL);			//\pϰN
}

void CGPIODlg::OnStartButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();

	// Port-A ̃`FbN
	int	nPortSetA	= m_pDoc->GetPortASet();
	if(nPortSetA == AXC_IO_IN_AD)
	{
		double		dData;
		CString		strBuf1;

		if(!pApp->m_AxcAcCtrl.GetPortAAData(&dData))
			return;

		strBuf1.Format(TEXT("%.3fv"),dData);
		m_INACtrl.SetWindowText(strBuf1);
	}
}

void CGPIODlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	if(nIDEvent == m_uTimer)
	{
		CAXCAC01App*	pApp		= (CAXCAC01App*)AfxGetApp();
		INT				nPortSetA;
		INT				nPortSetB;
		INT				nPortSetC;
		INT				nPortSetD;
		BYTE			byPort		= 0;
		BYTE			byTemp;
		BYTE			byOldPort	= m_pDoc->GetInData();

		// Port-A ̃`FbN
		nPortSetA	= m_pDoc->GetPortASet();
		if(nPortSetA == AXC_IO_IN)
		{
			if(!pApp->m_AxcAcCtrl.GetPortData(AXC_PORTA,&byTemp))
				return;
			byPort	|= (byTemp & 0x01);
		}

		// Port-B ̃`FbN
		nPortSetB	= m_pDoc->GetPortBSet();
		if(nPortSetB == AXC_IO_IN)
		{
			if(!pApp->m_AxcAcCtrl.GetPortData(AXC_PORTB,&byTemp))
				return;
			byPort	|= ((byTemp & 0x01) << 1);
		}

		// Port-C ̃`FbN
		nPortSetC	= m_pDoc->GetPortCSet();
		if(nPortSetC == AXC_IO_IN)
		{
			if(!pApp->m_AxcAcCtrl.GetPortData(AXC_PORTC,&byTemp))
				return;
			byPort	|= ((byTemp & 0x01) << 2);
		}

		// Port-D ̃`FbN
		nPortSetD	= m_pDoc->GetPortDSet();
		if(nPortSetD == AXC_IO_IN)
		{
			if(!pApp->m_AxcAcCtrl.GetPortData(AXC_PORTD,&byTemp))
				return;
			byPort	|= ((byTemp & 0x01) << 3);
		}
		
		// |[g̍XV
		m_pDoc->SetInData(byPort);
		
		byOldPort	^= byPort;
		
		// \̍XV
		if(nPortSetA == AXC_IO_IN)
		{
			if(byOldPort & 0x01)
				m_PABtn.Invalidate();
		}
		if(nPortSetB == AXC_IO_IN)
		{
			if(byOldPort & 0x02)
				m_PBBtn.Invalidate();
		}
		if(nPortSetC == AXC_IO_IN)
		{
			if(byOldPort & 0x04)
				m_PCBtn.Invalidate();
		}
		if(nPortSetD == AXC_IO_IN)
		{
			if(byOldPort & 0x08)
				m_PDBtn.Invalidate();
		}
	}

	CDialog::OnTimer(nIDEvent);
}
