// AXCAC01View.cpp : implementation of the CAXCAC01View class
//

#include "stdafx.h"
#include "AXCAC01.h"

#include "AXCAC01Doc.h"
#include "AXCAC01View.h"

#include "ADDlg.h"
#include "DADlg.h"
#include "GPIODlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAXCAC01View

IMPLEMENT_DYNCREATE(CAXCAC01View, CFormView)

BEGIN_MESSAGE_MAP(CAXCAC01View, CFormView)
	//{{AFX_MSG_MAP(CAXCAC01View)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_AD_BUTTON, OnAdButton)
	ON_BN_CLICKED(IDC_DA_BUTTON, OnDaButton)
	ON_BN_CLICKED(IDC_GPIO_BUTTON, OnGpioButton)
	ON_BN_CLICKED(IDC_END_BUTTON, OnEndButton)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAXCAC01View construction/destruction

CAXCAC01View::CAXCAC01View()
	: CFormView(CAXCAC01View::IDD)
{
	//{{AFX_DATA_INIT(CAXCAC01View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_uTimer	= 0;//dOFFh~p^C}
}

CAXCAC01View::~CAXCAC01View()
{
	int	i= 0;
}

void CAXCAC01View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAXCAC01View)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_TITLE1_BUTTON,	m_Title1Btn);
	DDX_Control(pDX, IDC_TITLE2_BUTTON,	m_Title2Btn);
	DDX_Control(pDX, IDC_CF_BUTTON,		m_CFBmpBtn);
	DDX_Control(pDX, IDC_LOGO_BUTTON,	m_LogoBtn);
	DDX_Control(pDX, IDC_AD_BUTTON,		m_ADBtn);
	DDX_Control(pDX, IDC_DA_BUTTON,		m_DABtn);
	DDX_Control(pDX, IDC_GPIO_BUTTON,	m_BmpBtn);
	DDX_Control(pDX, IDC_CF_STATIC, 	m_TitleCFCtrl);
	DDX_Control(pDX, IDC_COM_STATIC, 	m_TitleCOMCtrl);
	//}}AFX_DATA_MAP
}

BOOL CAXCAC01View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAXCAC01View diagnostics

#ifdef _DEBUG
void CAXCAC01View::AssertValid() const
{
	CFormView::AssertValid();
}

//void CAXCAC01View::Dump(CDumpContext& dc) const
//{
//	CFormView::Dump(dc);
//}

CAXCAC01Doc* CAXCAC01View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAXCAC01Doc)));
	return (CAXCAC01Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAXCAC01View message handlers

void CAXCAC01View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CAXCAC01Doc* pDoc	= GetDocument();

	// Bitmap Button ̐ݒ
	m_Title1Btn.SetDocument(pDoc);
	m_Title2Btn.SetDocument(pDoc);
	m_CFBmpBtn.SetDocument(pDoc);
	m_LogoBtn.SetDocument(pDoc);
	m_ADBtn.SetDocument(pDoc);
	m_DABtn.SetDocument(pDoc);
	m_BmpBtn.SetDocument(pDoc);

	CString	strFont;
	strFont = TEXT("lr@SVbN");

	m_TitleFont.CreateFont(-15,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);

	m_Title1Btn.SetFont(&m_TitleFont);
	m_Title2Btn.SetFont(&m_TitleFont);

	m_TitleCFCtrl.SetFont(&m_TitleFont);
	m_TitleCOMCtrl.SetFont(&m_TitleFont);

	m_SelFont.CreateFont(-15,0,0,0,FW_BOLD,0,1,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_ADBtn.SetFont(&m_SelFont);
	m_DABtn.SetFont(&m_SelFont);
	m_BmpBtn.SetFont(&m_SelFont);

//////////////////////////////////////////////////////////////////////////////
// for PocketPC2003
// 2004/09/08 +++<S>+++
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();

	pApp->InitAxcCard();
	pDoc->SetComPort(pApp->GetAxcPort());
// 2004/09/08 +++<E>+++
// 2004/09/13 +++<S>+++
	pDoc->SetAxcCF(pApp->GetAxcCard());

	// Bitmap Button ̐ݒ
	m_CFBmpBtn.SetDocument(pDoc);
	m_ADBtn.SetDocument(pDoc);
	m_DABtn.SetDocument(pDoc);
	m_BmpBtn.SetDocument(pDoc);

	m_CFBmpBtn.Invalidate();
	m_ADBtn.Invalidate();
	m_DABtn.Invalidate();
	m_BmpBtn.Invalidate();
// 2004/09/13 +++<E>+++

	m_uTimer	= SetTimer(1, 50000, NULL);//dOFFh~p^C}
//////////////////////////////////////////////////////////////////////////////
}

void CAXCAC01View::OnDraw(CDC* pDC) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	CRect	rcFrame;
	GetWindowRect(&rcFrame);

	pDC->FillRect(rcFrame, &CBrush(BACKGROUND_COLOR));			//lp`hԂ

	m_Title1Btn.MoveWindow(0,MAIN_BAR_Y1,rcFrame.Width(),MAIN_BAR_HEIGHT);
	m_Title2Btn.MoveWindow(0,MAIN_BAR_Y2,rcFrame.Width(),MAIN_BAR_HEIGHT);

	// E`
	CPen*	pOldPen;
	CPen	PenData1(PS_SOLID,1,PEN1_COLOR);
	CPen	PenData2(PS_SOLID,1,PEN2_COLOR);

	pOldPen		= pDC->SelectObject(&PenData2);
	pDC->MoveTo(0,MAIN_BAR_Y1+MAIN_BAR_HEIGHT);
	pDC->LineTo(rcFrame.Width(),MAIN_BAR_Y1+MAIN_BAR_HEIGHT);
	
	pDC->MoveTo(0,MAIN_BAR_Y2-1);
	pDC->LineTo(rcFrame.Width(),MAIN_BAR_Y2-1);
	pDC->MoveTo(0,MAIN_BAR_Y2+MAIN_BAR_HEIGHT);
	pDC->LineTo(rcFrame.Width(),MAIN_BAR_Y2+MAIN_BAR_HEIGHT);
	
	pDC->MoveTo(0,MAIN_SEPARATOR);
	pDC->LineTo(rcFrame.Width(),MAIN_SEPARATOR);
	
	pDC->SelectObject(pOldPen);

	CAXCAC01Doc* 	pDoc	= GetDocument();
	CString			strTemp;

	switch(pDoc->GetAxcCF())
	{
		case	AXC_AC_CF:
			strTemp.LoadString(IDS_AC_CF);
			break;
		case	AXC_AD_CF:
			strTemp.LoadString(IDS_AD_CF);
			break;
		case	AXC_DA_CF:
			strTemp.LoadString(IDS_DA_CF);
			break;
	}
	m_TitleCFCtrl.SetWindowText(strTemp);
	
	strTemp.Format(TEXT("COM %d"),pDoc->GetComPort());
	m_TitleCOMCtrl.SetWindowText(strTemp);
}

HBRUSH CAXCAC01View::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CFormView::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		if(pWnd == &m_TitleCFCtrl || pWnd == &m_TitleCOMCtrl)
		{
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(BACKGROUND_COLOR);
		}
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

void CAXCAC01View::OnAdButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	CADDlg*			pDlg;
	CAXCAC01Doc* 	pDoc	= GetDocument();
	
	if(pDoc->GetAxcCF() == AXC_DA_CF)
		return;

	pDlg	= new CADDlg(pDoc,this);
	pDlg->DoModal();
	
	delete	pDlg;	
}

void CAXCAC01View::OnDaButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CDADlg*			pDlg;
	CAXCAC01Doc* 	pDoc	= GetDocument();

	if(pDoc->GetAxcCF() == AXC_AD_CF)
		return;

	pDlg	= new CDADlg(pDoc,this);
	
	pDlg->DoModal();
	
	delete	pDlg;
}

void CAXCAC01View::OnGpioButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	CGPIODlg*		pDlg;
	CAXCAC01Doc* 	pDoc	= GetDocument();

	pDlg	= new CGPIODlg(pDoc,this);
	
	pDlg->DoModal();
	
	delete	pDlg;
}

void CAXCAC01View::OnEndButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	PostQuitMessage(0);
}

void CAXCAC01View::OnDestroy() 
{
	CFormView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	m_SelFont.DeleteObject();
	m_TitleFont.DeleteObject();
}


void CAXCAC01View::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(nIDEvent == m_uTimer)
	{
		SystemIdleTimerReset();//dOFFh~p^C}
	}
	
	CFormView::OnTimer(nIDEvent);
}

void CAXCAC01View::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_uTimer != 0)
	{
		KillTimer(m_uTimer);//dOFFh~p^C}I
		m_uTimer = 0;
	}
	CFormView::OnClose();
}
