// GPIOSetDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AXCAC01.h"
#include "GPIOSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGPIOSetDlg _CAO


CGPIOSetDlg::CGPIOSetDlg(CAXCAC01Doc* pDoc,CWnd* pParent /*=NULL*/)
	: CDialog(CGPIOSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGPIOSetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_pDoc	= pDoc;
}


void CGPIOSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGPIOSetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	DDX_Control(pDX, IDC_TITLE1_BUTTON,	m_Title1Btn);
	DDX_Control(pDX, IDC_PA_STATIC,		m_PortASt);
	DDX_Control(pDX, IDC_PB_STATIC,		m_PortBSt);
	DDX_Control(pDX, IDC_PC_STATIC,		m_PortCSt);
	DDX_Control(pDX, IDC_PD_STATIC,		m_PortDSt);
	DDX_Control(pDX, IDC_PA_COMBO,		m_PortACb);
	DDX_Control(pDX, IDC_PB_COMBO,		m_PortBCb);
	DDX_Control(pDX, IDC_PC_COMBO,		m_PortCCb);
	DDX_Control(pDX, IDC_PD_COMBO,		m_PortDCb);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGPIOSetDlg, CDialog)
	//{{AFX_MSG_MAP(CGPIOSetDlg)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_CBN_SELCHANGE(IDC_PA_COMBO, OnSelchangePaCombo)
	ON_CBN_SELCHANGE(IDC_PB_COMBO, OnSelchangePbCombo)
	ON_CBN_SELCHANGE(IDC_PC_COMBO, OnSelchangePcCombo)
	ON_CBN_SELCHANGE(IDC_PD_COMBO, OnSelchangePdCombo)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGPIOSetDlg bZ[W nh

BOOL CGPIOSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// Bitmap Button ̐ݒ
	m_Title1Btn.SetDocument(m_pDoc);

	CString	strFont;
	strFont = TEXT("lr@SVbN");

	m_TitleFont.CreateFont(-15,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_Title1Btn.SetFont(&m_TitleFont);

	m_StaticFont.CreateFont(-13,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_PortASt.SetFont(&m_StaticFont);
	m_PortBSt.SetFont(&m_StaticFont);
	m_PortCSt.SetFont(&m_StaticFont);
	m_PortDSt.SetFont(&m_StaticFont);

	m_ComboFont.CreateFont(-12,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,
						OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH | FF_SWISS, strFont);
	m_PortACb.SetFont(&m_ComboFont);
	m_PortBCb.SetFont(&m_ComboFont);
	m_PortCCb.SetFont(&m_ComboFont);
	m_PortDCb.SetFont(&m_ComboFont);

	INT	nPortMode;
	
	// PortA Setting
	nPortMode = m_pDoc->GetPortASet();
	switch(nPortMode)
	{
		case	AXC_IO_IN:
			m_PortACb.SetCurSel(0);
			break;
		case	AXC_IO_OUT_O:
			m_PortACb.SetCurSel(1);
			break;
		case	AXC_IO_OUT_P:
			m_PortACb.SetCurSel(2);
			break;
		case	AXC_IO_IN_AD:
			m_PortACb.SetCurSel(3);
			break;
	}
	if(m_pDoc->GetAxcCF() == AXC_DA_CF)
	{
		m_PortACb.DeleteString(3);
	}

	// PortB Setting
// 2004/03/18 +++<S>+++ OgKݒ̉e󂯂
	if(	(m_pDoc->GetADTrig() == AD_TRG_PB_U)	||
		(m_pDoc->GetADTrig() == AD_TRG_PB_D)	)
	{
		m_PortBCb.DeleteString(2);
		m_PortBCb.DeleteString(1);
	}
// 2004/03/18 +++<E>+++
	nPortMode = m_pDoc->GetPortBSet();
	switch(nPortMode)
	{
		case	AXC_IO_IN:
			m_PortBCb.SetCurSel(0);
			break;
		case	AXC_IO_OUT_O:
			m_PortBCb.SetCurSel(1);
			break;
		case	AXC_IO_OUT_P:
			m_PortBCb.SetCurSel(2);
			break;
	}

	// PortC Setting
	nPortMode = m_pDoc->GetPortCSet();
	switch(nPortMode)
	{
		case	AXC_IO_IN:
			m_PortCCb.SetCurSel(0);
			break;
		case	AXC_IO_OUT_O:
			m_PortCCb.SetCurSel(1);
			break;
		case	AXC_IO_OUT_P:
			m_PortCCb.SetCurSel(2);
			break;
	}

	// PortD Setting
	nPortMode = m_pDoc->GetPortDSet();
	switch(nPortMode)
	{
		case	AXC_IO_IN:
			m_PortDCb.SetCurSel(0);
			break;
		case	AXC_IO_OUT_O:
			m_PortDCb.SetCurSel(1);
			break;
		case	AXC_IO_OUT_P:
			m_PortDCb.SetCurSel(2);
			break;
	}

//////////////////////////////////////////////////////////////////////////////
// for PocketPC2003
// 2004/09/08 +++<S>+++
	ShowWindow(SW_SHOW);
// 2004/09/08 +++<E>+++
//////////////////////////////////////////////////////////////////////////////

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CGPIOSetDlg::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	CRect	rcFrame;
	GetWindowRect(&rcFrame);

	dc.FillRect(rcFrame, &CBrush(BACKGROUND_COLOR));			//lp`hԂ

	m_Title1Btn.MoveWindow(0	,GPIOSET_BAR_Y1	,rcFrame.Width()	,GPIOSET_BAR_HEIGHT);

	// E`
	CPen*	pOldPen;
	CPen	PenData1(PS_SOLID,1,PEN1_COLOR);
	CPen	PenData2(PS_SOLID,1,PEN2_COLOR);

	pOldPen		= dc.SelectObject(&PenData2);
	dc.MoveTo(0,GPIOSET_BAR_Y1+GPIOSET_BAR_HEIGHT);
	dc.LineTo(rcFrame.Width(),GPIOSET_BAR_Y1+GPIOSET_BAR_HEIGHT);

	dc.MoveTo(0,GPIOSET_BAR_Y2);
	dc.LineTo(rcFrame.Width(),GPIOSET_BAR_Y2);

	dc.SelectObject(pOldPen);

	// `pbZ[WƂ CDialog::OnPaint() ĂяoĂ͂܂
}

HBRUSH CGPIOSetDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: ̈ʒu DC ̃Agr[gύXĂ
	
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		if(	(pWnd == &m_PortASt)	||
			(pWnd == &m_PortBSt)	||
			(pWnd == &m_PortCSt)	||
			(pWnd == &m_PortDSt)	)
		{
			pDC->SetBkMode(TRANSPARENT);
			return ::CreateSolidBrush(BACKGROUND_COLOR);
		}
	}
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}

void CGPIOSetDlg::OnSelchangePaCombo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nSel	= m_PortACb.GetCurSel();
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
	BYTE			byData;
	
	switch(nSel)
	{
		case	0:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTA,AXC_IO_IN))
			{
				return;
			}
			m_pDoc->SetPortASet(AXC_IO_IN);
			break;
		case	1:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTA,AXC_IO_OUT_O))
			{
				return;
			}
			m_pDoc->SetPortASet(AXC_IO_OUT_O);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x01)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_LOW);
			break;
		case	2:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTA,AXC_IO_OUT_P))
			{
				return;
			}
			m_pDoc->SetPortASet(AXC_IO_OUT_P);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x01)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTA,AXC_LOW);
			break;
		case	3:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTA,AXC_IO_IN_AD))
			{
				return;
			}
			m_pDoc->SetPortASet(AXC_IO_IN_AD);
			break;
	}
}

void CGPIOSetDlg::OnSelchangePbCombo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nSel	= m_PortBCb.GetCurSel();
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
	BYTE			byData;

	switch(nSel)
	{
		case	0:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTB,AXC_IO_IN))
			{
				return;
			}
			m_pDoc->SetPortBSet(AXC_IO_IN);
			break;
		case	1:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTB,AXC_IO_OUT_O))
			{
				return;
			}
			m_pDoc->SetPortBSet(AXC_IO_OUT_O);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x02)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_LOW);
			break;
		case	2:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTB,AXC_IO_OUT_P))
			{
				return;
			}
			m_pDoc->SetPortBSet(AXC_IO_OUT_P);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x02)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTB,AXC_LOW);
			break;
	}
}

void CGPIOSetDlg::OnSelchangePcCombo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nSel	= m_PortCCb.GetCurSel();
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
	BYTE			byData;
	
	switch(nSel)
	{
		case	0:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTC,AXC_IO_IN))
			{
				return;
			}
			m_pDoc->SetPortCSet(AXC_IO_IN);
			break;
		case	1:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTC,AXC_IO_OUT_O))
			{
				return;
			}
			m_pDoc->SetPortCSet(AXC_IO_OUT_O);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x04)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_LOW);
			break;
		case	2:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTC,AXC_IO_OUT_P))
			{
				return;
			}
			m_pDoc->SetPortCSet(AXC_IO_OUT_P);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x04)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTC,AXC_LOW);
			break;
	}
}

void CGPIOSetDlg::OnSelchangePdCombo() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	INT				nSel	= m_PortDCb.GetCurSel();
	CAXCAC01App*	pApp	= (CAXCAC01App*)AfxGetApp();
	BYTE			byData;
	
	switch(nSel)
	{
		case	0:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTD,AXC_IO_IN))
			{
				return;
			}
			m_pDoc->SetPortDSet(AXC_IO_IN);
			break;
		case	1:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTD,AXC_IO_OUT_O))
			{
				return;
			}
			m_pDoc->SetPortDSet(AXC_IO_OUT_O);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x08)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_LOW);
			break;
		case	2:
			if(!pApp->m_AxcAcCtrl.SetPortMode(AXC_PORTD,AXC_IO_OUT_P))
			{
				return;
			}
			m_pDoc->SetPortDSet(AXC_IO_OUT_P);
			byData	= m_pDoc->GetOutData();
			if(byData & 0x08)
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_HIGH);
			else
				pApp->m_AxcAcCtrl.SetPortData(AXC_PORTD,AXC_LOW);
			break;
	}
}

void CGPIOSetDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	m_TitleFont.DeleteObject();			//̫ĵ޼ުĂ̔j
	m_StaticFont.DeleteObject();		//̫ĵ޼ުĂ̔j
	m_ComboFont.DeleteObject();			//̫ĵ޼ުĂ̔j
}
